export declare class AEMContainerComponent {
    /**
     * Map of model items included in the current container
     */
    cqItems: any;
    /**
     * Array of model item keys
     */
    cqItemsOrder: any;
    /**
     * Path to the model associated with the current instance of the component
     */
    cqPath: string;
    /**
     * Key of the model structure
     */
    modelName: string;
    /**
     * Class names of the current component
     */
    classNames: string;
    /**
     * Returns weather of not we are in the editor
     */
    get isInEditMode(): boolean;
    /**
     * Returns the aggregated path of this container path and the provided path
     *
     * @param path - the provided path to aggregate with the container path
     */
    getDataPath(path: any): any;
    /**
     * Returns the item data from the cqModel
     *
     * @param itemKey - the itemKey to look for in the items.
     */
    getItem(itemKey: any): any;
    /**
     * Returns the class names of the container based on the data from the cqModel
     */
    getHostClassNames(): string;
    get hostClasses(): string;
    /**
     * Returns the placeholder classes
     */
    getPlaceholderClassNames(): string;
    /**
     * Returns the placeholder path
     */
    get placeholderPath(): string;
}
